﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Slotnick_TextAdventure
{
    class Player
    {
            //player stats
            public static int currentHP = 100;
            public static int totalHP = 100;
            public static int currentMP = 100;
            public static int totalMP = 100;

            public static GameObj.InventoryItem weapon;
            public static GameObj.InventoryItem spell;
            public static GameObj.InventoryItem armor = new GameObj.InventoryItem("Street Clothes","A set of your favorite clothes",new GameObj.ItemEffect(0),"armor");

            /// <summary>
            /// does "damage" to the player. If they die they reset in the tower.
            /// </summary>
            /// <param name="damage"> damage done to the player</param>
            public static void Damage(int damage)
            {
                currentHP -= damage;
                if (currentHP < 1)
                {
                    currentHP = totalHP;
                    Tools.currentPosition = new Tools.PlayerPos(18, 48);
                    Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].enterEvent = "As the world bleeds away you wake up in the tower.|\"I can't do that a lot\" the old man says.|\"Be more careful next time.\"";
                    View.currentMenu = "";
                    View.cursorLocation[0] = 0;
                    View.cursorLocation[1] = 0;
                }
            }
            //player invintory
            public static GameObj.InventoryItem[] inventory = {new GameObj.InventoryItem("Empty", "Your backpack is Empty",new GameObj.ItemEffect(0), "none")};
            /// <summary>
            /// add an item to the invintory
            /// </summary>
            /// <param name="addMe">Item to Add </param>
            public static void AddItemToInv(GameObj.InventoryItem addMe)
            {
                
                List<GameObj.InventoryItem> tempInv = inventory.ToList();
                bool added = false;
                for (int x = 0; x < tempInv.Count; x++)
                {
                    if (tempInv[x].name == addMe.name)
                    {
                       
                            GameObj.InventoryItem newItem = tempInv[x];
                            newItem.count++;
                            tempInv.RemoveAt(x);
                            tempInv.Add(newItem);
                            added = true;
                    }
                    
                }
                if(!added)
                {
                        tempInv.Add(addMe);
                }
                inventory = tempInv.ToArray();

            }
            /// <summary>
            /// do you have an invetory?
            /// </summary>
            /// <returns></returns>
            public static bool HasInventory()
            {
                if (inventory.Length > 1)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            /// <summary>
            /// do you have all three quest items?
            /// </summary>
            /// <returns></returns>
            public static bool HasThreeQuest()
            {
                int questItemCount = 0;

                foreach (GameObj.InventoryItem isQuest in inventory)
                {
                    if (isQuest.slot != null)
                    {
                        if (isQuest.slot.ToLower() == "quest")
                        {
                            questItemCount++;
                        }
                    }
                }

                if (questItemCount == 3)
                {
                    return true;
                }

                return false;
            }
            /// <summary>
            /// use an tem in your inventory
            /// </summary>
            /// <param name="useMe">Item to use</param>
            public static void UseItemFromInv(GameObj.InventoryItem useMe)
            {
                if (useMe.name.ToLower() == "empty")
                {
                    return;
                }
                List<GameObj.InventoryItem> tempInv = inventory.ToList();
                if (useMe.slot.ToLower() == "weapon")
                {
                    if (weapon.name != null)
                    {
                        tempInv.Add(weapon);
                        weapon = useMe;
                        tempInv.Remove(useMe);
                    }
                    else
                    {
                        weapon = useMe;
                        tempInv.Remove(useMe);
                    }

                }
                if (useMe.slot.ToLower() == "spell")
                {
                    if (spell.name != null)
                    {
                        tempInv.Add(spell);
                        spell = useMe;
                        tempInv.Remove(useMe);
                    }
                    else
                    {
                        spell = useMe;
                        tempInv.Remove(useMe);
                    }
                }
                if (useMe.slot.ToLower() == "armor")
                {
                    if (armor.name != null)
                    {
                        tempInv.Add(armor);
                        armor = useMe;
                        tempInv.Remove(useMe);
                    }
                    else
                    {
                        armor = useMe;
                        tempInv.Remove(useMe);
                    }
                }
                if (useMe.slot.ToLower() == "potion")
                {
                    switch (useMe.effect.stat.ToLower())
                    {
                        case "hp":
                        case "heal":
                            if ((currentHP + useMe.effect.statBonus) > totalHP)
                            {
                                currentHP = totalHP;
                            }
                            else
                            {
                                currentHP += useMe.effect.statBonus;
                            }
                            break;
                        case "mp":
                        case "mana":
                            if ((currentHP + useMe.effect.statBonus) > totalHP)
                            {
                                currentMP = totalMP;
                            }
                            else
                            {
                                currentMP += useMe.effect.statBonus;
                            }
                            break;
                        default:
                            break;
                    }
                    
                    for (int x = 0; x < tempInv.Count; x++)
                    {
                        if (tempInv[x].name == useMe.name)
                        {
                            GameObj.InventoryItem newItem = tempInv[x];
                            newItem.count--;
                            tempInv.RemoveAt(x);
                            tempInv.Add(newItem);
                           
                            if (newItem.count <= 0)
                            {
                                tempInv.Remove(newItem);
                            }
                        }
                    }
                    
                   
                }


                
                inventory = tempInv.ToArray();

            }
        
    }
}
