﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Slotnick_TextAdventure
{
    class View
    {
        //display width = 80 characters
        //display height = 25 lines
        //Menu (bottom full width) 10 lines
        //Text/description 65x15 left hand side
        //map 15x15 right hand side
        //array structure length,height 
        //subtracing 2 on size for table borders
        static private char[,] display = new char[80, 25];
        static private char[,] menu = new char[78, 8];
        static private char[,] description = new char[63, 13];
        static private char[,] map = new char[13, 13];

        
        /// <summary>
        /// builds the borders
        /// </summary>
        private static void BuildBorder()
        {
            for (int x = 0; x < 80; x++)
            {
                for (int y = 0; y < 25; y++)
                {
                    if (x == 0 || x == 79 || y == 0 || y == 24 || y == 13 || x == 65 && y < 13)
                    {
                        display[x, y] = '*';
                    }
                    else
                    {
                        display[x, y] = ' ';
                    }
                }

            }
        } 

        public static string currentMenu = " ";
        public static string subMenu = " ";
        public static string[] thirdMenu = {};
        public static string[] selectedMenu = {};
        public static int[] cursorLocation = { 0, 0 };
        public static string[] basicMenu = { "Interact", "Take", "Use", "Attack", "Move", "Inventory" };
        public static string[] combatMenu = { "Melee", "Magic" , "Flee"};
        public static string[] itemMenu;
        public static string[] backpack;
        public static string[] tempMenu;
        public static string[] move = {"Press an arrow Key to move in a direction.",
                                       "   Press Any Other Key to access Menu.    "};
        /// <summary>
        /// Builds the menus
        /// </summary>
        private static void BuildMenu()
        {
            int firstMenuOffset = 1;
            int secondMenuOffset = 11;
            int thirdMenuOffset = 21;
            int statsOffset = 60;
            char cursor = '>';
            string[] move = {"Press an arrow Key to move in a direction.",
                             "   Press Any Other Key to access Menu.    "};
            string debugPosition = "X:" + Tools.currentPosition.x + " Y:" + Tools.currentPosition.y;
            string hpDisp = "HP: " + Player.currentHP + "/" + Player.totalHP;
            string mpDisp = "MP: " + Player.currentMP + "/" + Player.totalMP;
            //clear menu
            for (int insX = 0; insX < 76; insX++)
            {
                for (int insY = 0; insY < 6; insY++)
                {
                    menu[insX, insY] = ' ';
                }
            }
            
            //menu is 76 x 6
            for (int y = 0; y < 6; y++)
            {
                for (int x = 0; x < 76; x++)
                {

                    if (cursorLocation[0] == x && cursorLocation[1] == y)
                    {
                        menu[x, y] = cursor;
                    }

                    if (basicMenu.Length > y && basicMenu[y].Length > x)
                    {
                        menu[x + firstMenuOffset, y] = basicMenu[y][x];
                    }
                    
                    if (currentMenu != " " &&
                        selectedMenu != null &&
                        y < selectedMenu.Length  &&
                        selectedMenu[y] != null &&
                        selectedMenu[y].Length > x )
                    {//insert longer menu possibilties or make fewer objects...
                        menu[x + secondMenuOffset, y] = selectedMenu[y][x];
                    }
                    if (subMenu != " " && thirdMenu != null && y < thirdMenu.Length && thirdMenu[y].Length > x)
                    {
                        menu[x + thirdMenuOffset, y] = thirdMenu[y][x];
                    }
                    if (y == 0 && x < debugPosition.Length)
                    {
                        menu[x + statsOffset, y] = debugPosition[x];
                    }
                    if (y == 1 && x < hpDisp.Length)
                    {
                        menu[x + statsOffset, y] = hpDisp[x];
                    }
                    if (y == 2 && x < mpDisp.Length)
                    {
                        menu[x + statsOffset, y] = mpDisp[x];
                    }
                }

            }


            for (int insX = 0; insX < 76; insX++)
            {
                for (int insY = 0; insY < 6; insY++)
                {
                    display[insX + 1, insY + 14] = menu[insX, insY];
                }
            }
        }
       

        /// <summary>
        /// Builds the description window
        /// </summary>
        private static void BuildDescription()
        {
            string cShort = Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].shortDis;
            string cLong = Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].longDis;
            string cEvent = Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].enterEvent;
            
            //clear description
            for (int insX = 0; insX < 63; insX++)
            {
                for (int insY = 0; insY < 12; insY++)
                {
                    description[insX, insY]= ' ';
                }
            }

            //fix multiscreen events

            if (cEvent != "")
            {
                int y = 0;
                int x = 0;
                for (int temp = 0; temp < cEvent.Length; temp++)
                {
                    if (cEvent[temp] == '|') //next line
                    {
                        y++;
                        x = -1;
                    }
                    else
                    {
                        description[x, y] = cEvent[temp];
                    }

                    if (x < 62)
                    {
                        x++;
                    }
                    if (x > 62) //next line due to text length (expand to not cut words)
                    {
                        //cEvent = cEvent.Remove(0, 62);
                        x = 0;
                        y++;
                    }
                    if (y == 11)
                    {
                        string enterToCont = "                        Please Press any key for the next page";
                        for (int g = 0; g < enterToCont.Length; g++)
                        {
                            description[g, y] = enterToCont[g];
                        }
                        y = 0;
                        for (int insX = 0; insX < 63; insX++)
                        {
                            for (int insY = 0; insY < 12; insY++)
                            {
                                display[insX + 1, insY + 1] = description[insX, insY];
                            }
                        }
                        ;
                        OutputDisplay();
                        Tools.KeyPress();
                        for (int insX = 0; insX < 63; insX++) //clear description
                        {
                            for (int insY = 0; insY < 12; insY++)
                            {
                                description[insX, insY] = ' ';
                            }
                        }
                        cEvent = cEvent.Remove(0, temp);
                        temp = 0;
                    }
                }


                for (int insX = 0; insX < 63; insX++)
                {
                    for (int insY = 0; insY < 12; insY++)
                    {
                        display[insX + 1, insY + 1] = description[insX, insY];
                    }
                }

                Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].enterEvent = "";

            }
            else
            {
                for (int y = 0; y < 12; y++)
                {
                    if (y == 0)
                    {
                        for (int x = 0; x < cShort.Length; x++)
                        {
                            description[x, y] = cShort[x];
                        }
                    }
                    if (y == 2)
                    {
                        int x = 0;
                        for (int temp = 0; temp < cLong.Length; temp++)
                        {
                            if (cLong[temp] == '|') //next line
                            {
                                y++;
                                x = -1;
                            }
                            else
                            {
                                description[x, y] = cLong[temp];
                            }

                            if (x < 62)
                            {
                                x++;
                            }
                            if (x > 62) //next line due to text length (expand to not cut words)
                            {
                                cLong = cLong.Remove(0, 62);
                                x = 0;
                                y++;
                            }
                        }

                        y += 1;
                        if (Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].HasMonsters()) //print NPC's if they exist
                        {
                            for (int numMonster = 0; numMonster < Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].monsterList.Length; numMonster++)
                            {
                                if (Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].monsterList[numMonster].IsAlive())
                                {
                                    string monName = Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].monsterList[numMonster].MonsterName();
                                    monName = monName + " is here " + Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].monsterList[numMonster].State();
                                    for (int xPos = 0; xPos < monName.Length; xPos++)
                                    {
                                        description[xPos, y] = monName[xPos];
                                    }

                                }
                                else
                                {
                                    string monName = Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].monsterList[numMonster].MonsterName();
                                    monName = monName + "'s corpse is here.";
                                    for (int xPos = 0; xPos < monName.Length; xPos++)
                                    {
                                        description[xPos, y] = monName[xPos];
                                    }
                                }
                            }
                        }

                        y += 1;
                        if (Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].HasItems()) //print equipment's if it exists
                        {
                            for (int numItems = 0; numItems < Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].inventory.Length; numItems++)
                            {
                                string itemName = "";
                                itemName = "|A " + Tools.worldMap[Tools.currentPosition.x, Tools.currentPosition.y].inventory[numItems].name + " is here.";
                                for (int xPos = 0; xPos < itemName.Length; xPos++)
                                {
                                    if (itemName[xPos] == '|')
                                    {
                                        y++;
                                        xPos++;
                                    }

                                    description[xPos, y] = itemName[xPos];

                                }


                            }
                        }

                    }
                }
            }
                for (int insX = 0; insX < 63; insX++)
                {
                    for (int insY = 0; insY < 12; insY++)
                    {
                        display[insX + 1, insY + 1] = description[insX, insY];
                    }
                }
    
        }
        /// <summary>
        /// builds the map
        /// </summary>
        private static void BuildMap()
        {
            int tempX = 0;
            for (int xPos = 0; xPos < 150; xPos++)
            {
                
                int tempY = 0;
                for (int yPos = 0; yPos < 150; yPos++)
                {

                    if (xPos >= Tools.currentPosition.x - 6 && xPos <= Tools.currentPosition.x + 6 && yPos >= Tools.currentPosition.y - 6 && yPos <= Tools.currentPosition.y + 6)
                    {
                        if (Tools.worldMap[xPos, yPos].shortDis == null)
                        {
                            map[tempX, tempY] = 'X';
                        }
                        else
                        {
                            map[tempX, tempY] = ' ';
                        }
                        if (map[6, 6] == ' ')
                        {
                            map[6, 6] = '@';
                        }
                        if (tempY < 12 && yPos >= Tools.currentPosition.y - 6 && yPos <= Tools.currentPosition.y + 6)
                        {
                            tempY++;
                        }
                    }
                    
                }
                if (tempX < 12 && xPos >= Tools.currentPosition.x - 6 && xPos <= Tools.currentPosition.x + 6)
                {
                    tempX++;
                }
            }

            for (int insX = 0; insX < 12; insX++)
            {
                for (int insY = 0; insY < 12; insY++)
                {
                    display[insX + 66, insY + 1] = map[insX, insY];
                }
            }

        }
        /// <summary>
        /// builds the fight 
        /// </summary>
        /// <param name="combatText"></param>
        public static void BuildFight(string combatText)
        {
            for (int insX = 0; insX < 63; insX++)
            {
                for (int insY = 0; insY < 13; insY++)
                {
                    description[insX, insY] = ' ';
                }
            }

                int y = 0;
                int x = 0;
                for (int temp = 0; temp < combatText.Length; temp++)
                {
                    if (combatText[temp] == '\n') //next line
                    {
                        y++;
                        //combatText = combatText.Remove(0, x);
                        x = -1;
                    }
                    else
                    {
                        description[x, y] = combatText[temp];
                    }

                    if (x < 62)
                    {
                        x++;
                    }
                    if (x > 62) //next line due to text length (expand to not cut words)
                    {
                        combatText = combatText.Remove(0, 62);
                        x = 0;
                        y++;
                    }
                }

            
            for (int insX = 0; insX < 63; insX++)
            {
                for (int insY = 0; insY < 12; insY++)
                {
                    display[insX + 1, insY + 1] = description[insX, insY];
                }
            }
        }
        /// <summary>
        /// builds the display for fighting
        /// </summary>
        /// <param name="combatText"></param>
        public static void BuildFightDisplay(string combatText)
        {

            BuildBorder();
            BuildMap();
            BuildFight(combatText);
            BuildMenu();
            OutputDisplay();               
        }
        /// <summary>
        /// builds teh display for everything else
        /// </summary>
        public static void BuildDisplay()
        {
            //if (!Player.isFighting)
            //{
                BuildBorder();
                BuildMap();
                BuildMenu();
                BuildDescription();
                OutputDisplay();
            //}
        }
        
      /// <summary>
      /// outputs the display (thanks again prof palmer)
      /// </summary>
        public static void OutputDisplay()
        {
            // Prof. Palmer: Optimized to speed up drawing.  Instead of writing each character to the console,
            // instead we will build a single string that will be written with on Console.Write() call.

            // Set the WindowWidth a little bigger to accomodate the additional newline characters
            Console.WindowWidth = 81;
            Console.CursorVisible = false;
               
            // Using a StringBuilder will improve performance
            StringBuilder sb = new StringBuilder();

            for (int y = 0; y < 25; y++)
            {
                for (int x = 0; x < 80; x++)
                {
                    sb.Append(display[x, y]);
                }
                // Add a new line to all but the last line
                if(y < 24)
                    sb.Append("\n");
            }
            // sb.ToString() will dump the contents of the StringBuilder as a string to the console
            Console.Write(sb.ToString());
            Console.SetCursorPosition(0, 0);
        }

    }
}
